Decode Ways – LeetCode Solution [Medium]

Problem

A message containing letters from A-Z can be encoded into numbers using the following mapping:

'A' -> "1"
'B' -> "2"
...
'Z' -> "26"

To decode an encoded message, all the digits must be grouped then mapped back into letters using the reverse of the mapping above (there may be multiple ways). For example, "11106" can be mapped into:

  • "AAJF" with the grouping (1 1 10 6)
  • "KJF" with the grouping (11 10 6)

Note that the grouping (1 11 06) is invalid because "06" cannot be mapped into 'F' since "6" is different from "06".

Given a string s containing only digits, return the number of ways to decode it.

LeetCode Problem Link

Solution

This problem could be solved by Dynamic programming (Bottom up approach).

Base case:

if (s[0] == '0') {
 return 0;
}

//Considering only single number
s[0] = 1;
s[1] = 1;

This is because,
All the digits must be grouped then mapped back into letters“
And ‘0’ can’t be mapped to any digit.

So now, optimal substructure for tabulation:

int sol[MAX] = {0};

//Considering solution from previous digit
if (s[i-1] != '0') {
   sol[i] = sol[i-1]
}

//Adding solution from previous two digits,
//if it is less than 27
if (s[i-2] != '0' && 
((s[i-2]-'0')*10 + (s[i-1]-'0')) < 27) {
    sol[i]+=sol[i-2];
}

return sol[s.size()];

Code Implementation

int numDecodings(string s) {
    int* dp = new int[s.size()+1]();
    
    dp[0] = 1;
    dp[1] = 1;
    
    if (s[0] == '0') {
        return 0;
    }
    
    for (int i=2; i<=s.size(); i++) {
        if (s[i-1] != '0') {
            dp[i] += dp[i-1];
        }
        int charVal = (s[i-2] - '0')*10 + s[i-1]-'0';
        if (s[i-1] != 0 && charVal < 27 && charVal >= 10) {
            dp[i] += dp[i-2];
        }
    }

    return dp[s.size()];
}

Here’s a working example: Decode Ways Solution

Leave a Reply

Your email address will not be published. Required fields are marked *